Category: Accounts / authentication Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

As an alternative to gravatar support, could we have libravatar support as well?

http:/libravatar.org/ provides the same sort of service as Gravatar, but instead of forcing you to host your data on a central service,
allows federation out to multiple servers -- so you could have automatic support for fallthrough to one set of images for internal
company use, another for official external use, or images hosted on libravatar.org itself, with additional fallback onto gravatar as well

Related issues:
Related to Redmine - Patch #31022: Always use HTTPS when accessing gravatar.com
Blocked by Redmine - Defect #31428: Gravatar can't be displayed when copy con...

Closed
Closed

Associated revisions

Revision 18124 - 2019-05-04 17:59 - Go MAEDA

Add avatar_server_url configuration option in order to support Libravatar (#9112).

Patch by Go MAEDA.

Revision 18125 - 2019-05-04 18:03 - Go MAEDA
Update locales (#9112).

Revision 18192 - 2019-05-23 10:28 - Go MAEDA

Gravatar icons are broken if configuration.yml.example file is used as is (#9112, #31428).

Contributed by Mizuki ISHIKAWA.

History

#1 - 2011-08-24 09:00 - Etienne Massip
- Category set to Third-party libraries

Could be done with a plugin.

#2 - 2011-08-24 12:31 - Francois Marier

The Libravatar Gem might be useful:

https: rubygems.org/gems/libravatar
https://github.com/gugod/libravatar

#3 - 2015-06-21 13:37 - n ext

Is there any progress yet? IMHO it's an much more privacy respecting solution that should be introduced upstream as gravatar is already?

#4 - 2017-05-16 09:30 - Sandro Santilli

Upvoting this, | hate to be forced to have my face served by gravatar.com :/

#5 - 2019-05-02 11:35 - Oliver Falk
Hi!
http://libravatar.org/

Libravatar has been recently completely renewed and now shines again.

Changing from Gravatar to Libravatar is only a matter of changing the "base URL". It's completely compatible with Gravatar. The default even is to
proxy to Gravatar. With proxy | mean, real proxying; Gravatar doesn't see the client IP and therefore preserving user privacy.

This is really low hanging fruit, as you do not really need to change the module you use, if this is too much work. You just need to replace the URL.

https://secure.gravatar.com/ => https://secure.libravatar.org

Thanks and kind regards,
Oliver

#6 - 2019-05-02 14:51 - Go MAEDA
- File avatar_service_url_configuration.patch added
What do you think about the attached patch?

The patch introduces a new configuration option "avatar_service_url". You can switch to Libravatar by setting the option in the configuration.yml file
like this.

avatar_service_url: https://seccdn.libravatar.org

#7 - 2019-05-02 15:04 - Oliver Falk

Hi!
In principle | like this! If | may suggest: Put it the other way round and make Libravatar the default :-)
| doesn't change anything for the user/admin, except they'll have better privacy.

#8 - 2019-05-02 15:29 - Go MAEDA
- Category changed from Third-party libraries to Accounts / authentication

- Target version set to Candidate for next major release
#9 - 2019-05-02 22:25 - Jim Cheetham
Thanks for promoting this again Oliver Cordero :-)
The patch as presented gives the admin the option to easily select their own service, which is excellent.
We still have a hard-coded portion, /avatar/' + hash, and this should be surfaced in the documentation at least, and probably in the configuration file
as well. But to be fair, this is the published API for both Libravatar and Gravatar, and is probably just as static as the formation of the hash itself. It's
been correct for many years now ...
The argument of which should be the default is going a step further than | was asking for, and whereas 7 years ago | was happy for this to be just an
option these days | think more people are sensitive to privacy concerns. However, technically this patch provides good capability, and I'm happy to
see it moving on.
Of course | now wish I'd dug in to the code myself all those years ago and written the patch myself!
#10 - 2019-05-03 08:34 - Go MAEDA
- File avatar_service_url_configuration-v2.patch added
Updated the patch. Now it includes test code.
Jim Cheetham wrote:
We still have a hard-coded portion, ‘/avatar/' + hash, and this should be surfaced in the documentation at least, and probably in the configuration
file as well.

| have described what URLs are generated in configuraition.yml.example. Thank you for reviewing the patch.

But to be fair, this is the published API for both Libravatar and Gravatar, and is probably just as static as the formation of the hash itself. It's been
correct for many years now ...

I think hard-coding ‘/avatar/' is OK because DNS-based server discovery mechanism described on https://wiki.libravatar.org/api/ assumes that the
path is always ‘/avatar/'

#11 - 2019-05-03 10:11 - Oliver Falk
Hi!
https://www.redmine.org/users/17724
https://wiki.libravatar.org/api/

Yes, hardcoding /avatar/ should be fine. I'm pretty sure all services are using this path in order to be compatible with Gravatar. If - for some reason -
someone has a different path with his service, he needs to rewrite it in the web server configuration accordingly - not really our issue.

Glad you enhanced the code with tests.

| would still love to see Libravatar be the default or some way how we could potentially encourage users to switch to Libravatar if it's not the default -
but it is your decision and not mine of course.

Thanks for your work on this - highly appreciated!!
#12 - 2019-05-03 13:35 - Go MAEDA
- Target version changed from Candidate for next major release to 4.1.0
Oliver Falk wrote:
| would still love to see Libravatar be the default or some way how we could potentially encourage users to switch to Libravatar if it's not the

default - but it is your decision and not mine of course.

| don't think we should make Libravatar the default because most people probably use Gravatar instead of Libravatar. In addition, | have doubts about
the continuity of libravatar.org (see the articles below).

https://blog.libravatar.org/posts/Libravatar.org_is_shutting_down_on_2018-09-01/

https://blog.libravatar.org/posts/Libravatar.org_is_not_going_away/

Anyway, supporting Gravatar-compatible servers including Libravatar is easy, and | think it is valuable because it gives users another choice. | am
setting the target version to 4.1.0.

#13 - 2019-05-03 13:58 - Oliver Falk
Hi!

| don't think we should make Libravatar the default because most people probably use Gravatar
instead of Libravatar.

By default Libravatar proxies to Gravatar and therefore it doesn't make any difference to the user, apart from more privacy, since Gravatar only sees
the proxy address.

In addition, | have doubts about the continuity of libravatar.org (see the articles below).
https://blog.libravatar.org/posts/Libravatar.org_is_shutting_down_on_2018-09-01/
https://blog.libravatar.org/posts/Libravatar.org_is_not_going_away/

| know those articles. I'm basically the reason behind the 'is not going away'. Software has been rewritten by me and is now hosted on Fedora
Infrastructure - so really no doubits if it's staying or not. It IS staying. ;-)

Oliver

#14 - 2019-05-04 03:53 - Go MAEDA
- Related to Patch #31022: Always use HTTPS when accessing gravatar.com added

#15 - 2019-05-04 04:10 - Go MAEDA

- File avatar_service_url_configuration-v3.patch added

Updated the patch. | have changed the config name from avatar_service_url to avatar_server_url because users may use their own avatar server
instead of services such as Gravatar and Libravatar.

You can see the list of opensource Gravatar-compatible servers: https://wiki.libravatar.org/running_your_own/

#16 - 2019-05-04 11:12 - Go MAEDA
- File text_avatar_server_config_html@2x.png added

- File avatar_service_url_configuration-v4.patch added

Added a message about the avatar server configuration on the settings page. Users will have a chance to know by this message that the avatar
server is configurable.
https://blog.libravatar.org/posts/Libravatar.org_is_shutting_down_on_2018-09-01/
https://blog.libravatar.org/posts/Libravatar.org_is_not_going_away/
https://blog.libravatar.org/posts/Libravatar.org_is_shutting_down_on_2018-09-01/
https://blog.libravatar.org/posts/Libravatar.org_is_not_going_away/
https://wiki.libravatar.org/running_your_own/

Use Gravatar user icons @

https://seccdn.libravatar.org

Default Gravatar image Identicons

#17 - 2019-05-04 15:23 - Marius BALTEANU

Nice addition.

#18 - 2019-05-04 18:00 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you all for suggesting this feature.

#19 - 2019-05-17 07:55 - Oliver Falk
Go MAEDA wrote:

Committed the patch. Thank you all for suggesting this feature.

Awesome! Thanks a lot for your work!

Oliver

#20 - 2019-05-23 07:45 - Go MAEDA

- Status changed from Closed to Reopened

#21 - 2019-05-23 07:46 - Go MAEDA
- Blocked by Defect #31428: Gravatar can't be displayed when copy configration.yml.example to configration.yml added

#22 - 2019-05-23 10:29 - Go MAEDA

- Status changed from Reopened to Closed

Committed the fix for #31428 in r18192.

#23 - 2019-08-31 04:22 - Go MAEDA

- Subject changed from Libravatar support to Libravatar and Gravatar-compatible servers support

Files

avatar_service_url_configuration.patch 1.52 KB 2019-05-02 Go MAEDA
avatar_service_url_configuration-v2.patch 3.73 KB 2019-05-03 Go MAEDA
avatar_service_url_configuration-v3.patch 3.72 KB 2019-05-04 Go MAEDA
text_avatar_server_config_htmi@2x.png 13.6 KB 2019-05-04 Go MAEDA
avatar_service_url_configuration-v4.patch 5.37 KB 2019-05-04 Go MAEDA
